src/Entity/Journalist.php
<?php

namespace App\Entity;

use Doctrine\Common\Collections\ArrayCollection;
use Doctrine\Common\Collections\Collection;
use Doctrine\ORM\Mapping as ORM;
use Serializable;
use Symfony\Component\Security\Core\User\UserInterface;

/**
 * @ORM\Entity(repositoryClass="App\Repository\JournalistRepository")
 */
class Journalist implements UserInterface
{
    /**
     * @ORM\Id()
     * @ORM\GeneratedValue()
     * @ORM\Column(type="integer")
     */
    private $id;

    /**
     * @ORM\Column(type="string", length=180, unique=true)
     */
    private $email;

    /**
     * @ORM\Column(type="json")
     */
    private $roles = [];

    /**
     * @var string The hashed password
     * @ORM\Column(type="string")
     */
    private $password;

    /**
     * @ORM\Column(type="string", length=255)
     */
    private $name;

    /**
     * @ORM\Column(type="string", length=255)
     */
    private $surname;

    /**
     * @ORM\Column(type="integer")
     */
    private $age;

    /**
     * @ORM\Column(type="string", length=255)
     */
    private $nationality;

    /**
     * @ORM\Column(type="string", length=255)
     */
    private $speciality;

    /**
     * @ORM\Column(type="string", length=255)
     */
    private $imgPath;
    

    /**
     * @ORM\Column(type="string", length=255)
     */
    private $description;

    /**
     * @ORM\OneToMany(targetEntity="App\Entity\Media", mappedBy="journalist", cascade={"remove"})
     */
    private $Media;

    /**
     * @ORM\OneToMany(targetEntity="App\Entity\PromoMedia", mappedBy="journalist")
     */
    private $PromoMedia;

    public function __construct()
    {
        $this->Media = new ArrayCollection();
        $this->PromoMedia = new ArrayCollection();
    }

    public function getId(): ?int
    {
        return $this->id;
    }

    public function getEmail(): ?string
    {
        return $this->email;
    }

    public function setEmail(string $email): self
    {
        $this->email = $email;

        return $this;
    }

    /**
     * A visual identifier that represents this user.
     *
     * @see UserInterface
     */
    public function getUsername(): string
    {
        return (string) $this->email;
    }

    /**
     * @see UserInterface
     */
    public function getRoles(): array
    {
        $roles = $this->roles;
        // guarantee every user at least has ROLE_USER
        $roles[] = 'ROLE_USER';

        return array_unique($roles);
    }

    public function setRoles(array $roles): self
    {
        $this->roles = $roles;

        return $this;
    }

    /**
     * @see UserInterface
     */
    public function getPassword(): string
    {
        return (string) $this->password;
    }

    public function setPassword(string $password): self
    {
        $this->password = $password;

        return $this;
    }

    /**
     * @see UserInterface
     */
    public function getSalt()
    {
        // not needed when using the "bcrypt" algorithm in security.yaml
    }

    /**
     * @see UserInterface
     */
    public function eraseCredentials()
    {
        // If you store any temporary, sensitive data on the user, clear it here
        // $this->plainPassword = null;
    }

    public function getName(): ?string
    {
        return $this->name;
    }

    public function setName(string $name): self
    {
        $this->name = $name;

        return $this;
    }

    public function getSurname(): ?string
    {
        return $this->surname;
    }

    public function setSurname(string $surname): self
    {
        $this->surname = $surname;

        return $this;
    }

    public function getAge(): ?int
    {
        return $this->age;
    }

    public function setAge(int $age): self
    {
        $this->age = $age;

        return $this;
    }

    public function getNationality(): ?string
    {
        return $this->nationality;
    }

    public function setNationality(string $nationality): self
    {
        $this->nationality = $nationality;

        return $this;
    }

    public function getSpeciality(): ?string
    {
        return $this->speciality;
    }

    public function setSpeciality(string $speciality): self
    {
        $this->speciality = $speciality;

        return $this;
    }

    public function getImgPath()
    {
        return $this->imgPath;
    }

    public function setImgPath($imgPath)
    {
        $this->imgPath = $imgPath;

        return $this;
    }

    public function getDescription(): ?string
    {
        return $this->description;
    }

    public function setDescription(string $description): self
    {
        $this->description = $description;

        return $this;
    }

    /**
     * @return Collection|Media[]
     */
    public function getMedia(): Collection
    {
        return $this->Media;
    }

    public function addMedium(Media $medium): self
    {
        if (!$this->Media->contains($medium)) {
            $this->Media[] = $medium;
            $medium->setJournalist($this);
        }

        return $this;
    }

    public function removeMedium(Media $medium): self
    {
        if ($this->Media->contains($medium)) {
            $this->Media->removeElement($medium);
            // set the owning side to null (unless already changed)
            if ($medium->getJournalist() === $this) {
                $medium->setJournalist(null);
            }
        }

        return $this;
    }

    /**
     * @return Collection|PromoMedia[]
     */
    public function getPromoMedia(): Collection
    {
        return $this->PromoMedia;
    }

    public function addPromoMedium(PromoMedia $promoMedium): self
    {
        if (!$this->PromoMedia->contains($promoMedium)) {
            $this->PromoMedia[] = $promoMedium;
            $promoMedium->setJournalist($this);
        }

        return $this;
    }

    public function removePromoMedium(PromoMedia $promoMedium): self
    {
        if ($this->PromoMedia->contains($promoMedium)) {
            $this->PromoMedia->removeElement($promoMedium);
            // set the owning side to null (unless already changed)
            if ($promoMedium->getJournalist() === $this) {
                $promoMedium->setJournalist(null);
            }
        }

        return $this;
    }

    public function __toString()
    {
        return $this->getName();
    }
    
    
}

src/Form/JournalistType.php
<?php

namespace App\Form;

use App\Entity\Journalist;
use Symfony\Component\Form\AbstractType;
use Symfony\Component\Form\Extension\Core\Type\FileType;
use Symfony\Component\Form\FormBuilderInterface;
use Symfony\Component\OptionsResolver\OptionsResolver;

class JournalistType extends AbstractType
{
    public function buildForm(FormBuilderInterface $builder, array $options)
    {
        $builder
            ->add('email')
            ->add('password')
            ->add('name')
            ->add('surname')
            ->add('age')
            ->add('nationality')
            ->add('speciality')      
            ->add('description')
            ->add('imgPath');
    }

    public function configureOptions(OptionsResolver $resolver)
    {
        $resolver->setDefaults([
            'data_class' => Journalist::class,
            'allow_extra_fields' => true
        ]);
    }
}

src/Controller/JournalistController.php
<?php

namespace App\Controller;

use App\Entity\Journalist;
use App\Form\JournalistType;
use App\Repository\JournalistRepository;
use Doctrine\ORM\EntityManagerInterface;
use Symfony\Bundle\FrameworkBundle\Controller\AbstractController;
use Symfony\Component\HttpFoundation\Request;
use Symfony\Component\Routing\Annotation\Route;
use Symfony\Component\Security\Core\Encoder\UserPasswordEncoderInterface;
use App\Service\FileUploader;
use Symfony\Component\HttpFoundation\File\File;
use Symfony\Component\Security\Core\Authentication\Token\Storage\TokenStorageInterface;

class JournalistController extends AbstractController
{
    /**
     * @Route("/journalist", name="journalist")
     */
    public function form(Request $request, EntityManagerInterface $manager, UserPasswordEncoderInterface $encoder)
    {
        $journalist = new Journalist();
        $form = $this->createForm(JournalistType::class, $journalist);

        $form->handleRequest($request);

        if ($form->isSubmitted() && $form->isValid()) {
            $journalist->setRoles(['ROLE_JOURNALIST']);
            $hashedPassword = $encoder->encodePassword($journalist, $journalist->getPassword());
            $journalist->setPassword($hashedPassword);
            $manager->persist($journalist);
            $manager->flush();

            return $this->redirectToRoute('app_login');
        }

        return $this->render('journalist/FormAccount.html.twig', [
            'JournalistForm' => $form->createView()
        ]);
    }
    /**
     * @Route("/profile/{id}", name="profile_journalist")
     */
    public function index(Journalist $journalist){

        return $this->render('journalist/pageJournalist.html.twig', [
            'profil_journalist'=> $journalist
        ]);
    }

    /**
     * @Route("/journalist/{code}", name="country")
     */
    public function country(JournalistRepository $journalistRepository, string $code){

        return $this->render('NewFeed/mediaForm.html.twig', [
            'country' => $journalistRepository->findBy(["nationality"->$code]),
        ]);
    
    }

    /**
     * @Route("/modify_profile/{id}", name="modify_profile")
     */
    public function modify($id, Request $request)
    {
        
        $entityJournalist = $this->getDoctrine()->getManager();
        $pro = $entityJournalist->getRepository(Journalist::class)->find($id);

        if (!$pro) {
            throw $this->createNotFoundException(
                'No product found for id ' . $id
            );
        }
        $form = $this->createForm(JournalistType::class, $pro);
        $form->handleRequest($request);
        if ($form->isSubmitted() && $form->isValid()) {
            $entityJournalist->persist($pro);
            $entityJournalist->flush();
            return $this->redirectToRoute('profile_journalist', [
                'id' => $pro->getId()
            ]);
        }
        return $this->render('journalist/FormAccount.html.twig', [
            'JournalistForm' => $form->createView()
        ]);
    }

    /**
     * @Route("/delete_profile", name="delete_profile")
     */
    public function deleteJournalist(TokenStorageInterface $tokenStorageInterface)
    {
        $entityJournalist = $this->getDoctrine()->getManager();
        $journalist = $this->getUser();
        $entityJournalist->remove($journalist);
        $entityJournalist->flush();
        $tokenStorageInterface->setToken();
        return $this->redirectToRoute('app_home');
    }

    /**
     * @Route("/add_picture", name="picture_add")
     */
    // public function addPicture(Request $request, EntityManagerInterface $manager, FileUploader $FileUploader)
    // {
    //     $journalist = new Journalist();
        
    //     $form = $this->createForm(JournalistType::class, $journalist);
    //     $form->handleRequest($request);

    //     if($form->isSubmitted() && $form->isValid()) {
    //         $imgPath = $FileUploader->upload($journalist->getImgPath());

    //         $journalist->setImgPath($imgPath);
    //         $manager->persist($journalist);
    //         $manager->flush();
    //         return $this->redirectToRoute('');
    //     }

    //     return $this->render('journalist/FormAccount.html.twig', [
    //         'form' => $form->createView()
    //     ]);
    // }

}

templates/journalist/FormAccount.html.twig
{% extends 'base.html.twig' %}

{% block title %}Hello JournalistController!{% endblock %}

{% block body %}
<div class = 'row col-lg-6 d-flex flex-column'>
    {{form_start (JournalistForm)}}
    {{form_widget (JournalistForm)}}  
    <button class="btn btn-primary">Submit</button>
    {{form_end (JournalistForm)}}
    
  </div> 
  

{% endblock %}

templates/journalist/pageJournalist.html.twig
{% extends 'base.html.twig' %}

{% block body %}
{% include "home/nav.html.twig" %}


<ul class="nav nav-tabs col-lg-12" id="myTab" role="tablist">
    <li class="nav-item col-lg-3">
      <a class="nav-link active" id="home-tab" data-toggle="tab" href="#infos" role="tab" aria-controls="home" aria-selected="true">Infos</a>
    </li>
    <li class="nav-item col-lg-3">
      <a class="nav-link" id="profile-tab" data-toggle="tab" href="#medias" role="tab" aria-controls="profile" aria-selected="false">Medias</a>
    </li>
    {% if app.user %}
    <li class="mb-3 col-lg-6 d-flex justify-content-end">
        You are logged in as {{ app.user.name }}, <a href="{{ path('app_logout') }}">Logout</a>
    </li>
  {% endif %}
  </ul>
<div class="tab-content" id="myTabContent">
    <div class="tab-pane fade show active" id="infos" role="tabpanel" aria-labelledby="infos-tab">
        <a  href="{{path('modify_profile', {id: profil_journalist.id}) }}" class="btn btn-danger">Modify</a>
        <a  href="{{path('delete_profile', {id: profil_journalist.id}) }}" class="btn btn-danger">Delete</a>
        <div class="row justify-content-center m-4">
            <div class="col-lg-4 p-3 ">
                <div class="card bg-dark"> Name:
                    <div class="card-body ">{{profil_journalist.name}}</div>
                </div>   
            </div>
            <div class="col-lg-4 p-3">
                <div class="card bg-dark"> Surname: 
                    <div class="card-body ">{{profil_journalist.surname}}</div>
                </div>   
            </div>
            <div class="col-lg-4 p-3 ">
                <div class="card bg-dark">Old:
                    <div class="card-body ">{{profil_journalist.age}}years old</div>
                </div>   
            </div>
        </div>
        <div class="row justify-content-center m-4">
            <div class="col-lg-4 p-3 ">
                <div class="card bg-dark">Nationality:
                    <div class="card-body">{{profil_journalist.nationality}}</div>
                </div>   
            </div>
            <div class="col-lg-4 p-3 ">
                <div class="card bg-dark">Speciality:
                    <div class="card-body ">{{profil_journalist.speciality}}</div>
                </div>   
            </div>
            <div class="col-lg-4 p-3 ">
                <div class="card bg-dark">Email:
                    <div class="card-body ">{{profil_journalist.email}}</div>
                </div>   
            </div>
        </div>
        <div class="row justify-content-center m-4">
            <div class="col-lg-12 p-3 ">
                <div class="card bg-dark">Your description:
                    <div class="card-body">{{profil_journalist.description}}</div>
                </div>   
            </div>
        </div>
    </div>
    
    <div class="tab-pane fade" id="medias" role="tabpanel" aria-labelledby="profile-tab">
        <a href="{{path('form_media') }}" class="btn btn-success">Add</a>
        {% for media_profile in profil_journalist.media %}
        <div class="catd-body p-5">
            <div class="row justify-content-center text-white">
                
                     <div class="col-lg-6 "style="border:solid rgb(255, 0, 140) 2px; border-radius:30px;">
                    <h5>{{media_profile.title}}</h5>
                        <p>{{media_profile.author}}</p> 
                        <p>{{media_profile.description}}</P>
                    <video width="400" controls>
                        <source src="ht" type="video">
                      </video>
                </div>
            </div>
            <div class="row">
                <div class="col-12">
                    <div class="row">
                        <div class="col-lg-12">
                        </div>
                    </div>
                </div>
            </div>         
        </div>
        {% endfor %}  
    </div>
 </div>


{% include "home/footer.html.twig" %}
{% endblock %}